// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
  'cloudera/cmf/charts/PlotContainer'
], function(PlotContainer) {
  describe("PlotContainer Tests", function() {
    var module, container = "plotContainer", options = {
      container: container,
      plot: {
        tsquery: "Some Query",
        chartType: "line"
      }
    };

    beforeEach(function() {
      $('<div id="#' + container+ '"></div>').appendTo(document.body);
    });

    afterEach(function() {
      $("#" + container).remove();
      module.unsubscribe();
    });

    it("should create a PlotContainer object", function() {
      module = new PlotContainer(options);
      var plot = module.getPlot();
      expect(options.plot.tsquery).toEqual(plot.tsquery);
      expect(options.plot.chartType).toEqual(plot.chartType);
    });

    it("should call setChartType", function() {
      module = new PlotContainer(options);
      spyOn(module.getViewModel(), "setChartType").andCallThrough();
      module.setChartType("stackarea");
      expect(module.getViewModel().setChartType).wasCalledWith("stackarea");

      var plot = module.getPlot();
      expect(plot.chartType).toEqual("stackarea");
    });

    it("should call setTsquery", function() {
      module.setTsquery("SOMEOTHERQUERY");
      expect(module.getViewModel().tsquery()).toEqual("SOMEOTHERQUERY");
      var plot = module.getPlot();
      expect(plot.tsquery).toEqual("SOMEOTHERQUERY");
    });

    it("should call setDimension", function() {
      spyOn(module.getViewModel(), "setDimension");
      module.setDimension(10, 20);
      expect(module.getViewModel().setDimension).wasCalledWith(10, 20);
    });

    it("should call getBoundTsquery", function() {
      spyOn(module.getViewModel(), "getBoundTsquery");
      module.getBoundTsquery();
      expect(module.getViewModel().getBoundTsquery).wasCalled();
    });
  });
});
